# TabPy

[![Community Supported](https://img.shields.io/badge/Support%20Level-Community%20Supported-457387.svg)](https://www.tableau.com/support-levels-it-and-developer-tools)
[![GitHub](https://img.shields.io/badge/license-MIT-brightgreen.svg)](https://raw.githubusercontent.com/Tableau/TabPy/master/LICENSE)
[![Build Status](https://img.shields.io/travis/com/tableau/TabPy.svg?branch=master)](https://travis-ci.com/tableau/TabPy)
[![Coverage Status](https://img.shields.io/coveralls/github/tableau/TabPy.svg)](https://coveralls.io/github/tableau/TabPy)
[![Scrutinizer Code Quality](https://scrutinizer-ci.com/g/tableau/TabPy/badges/quality-score.png?b=master)](https://scrutinizer-ci.com/g/tableau/TabPy/?branch=master)

[![Python 3.6](https://img.shields.io/badge/python-3.6-blue.svg)](https://www.python.org/downloads/release/python-360/)

![Release](https://img.shields.io/github/release/tableau/TabPy.svg)

TabPy (the Tableau Python Server) is an external service implementation which expands
Tableau's capabilities by allowing users to execute Python scripts and saved functions
via Tableau's table calculations.

Consider reading TabPy documentation in the following order:

* [About TabPy](docs/about.md)
* [TabPy Installation Instructions](docs/server-install.md)
* [TabPy Server Configuration Instructions](docs/server-config.md)
* [Running TabPy in Python Virtual Environment](docs/tabpy-virtualenv.md)
* [Authoring Python calculations in Tableau](docs/TableauConfiguration.md).
* [TabPy Tools](docs/tabpy-tools.md)

Troubleshooting:

* [FAQ for configuration, startup and other issues](docs/FAQ.md)

More technical topics:

* [Contributing Guide](CONTRIBUTING.md) for TabPy developers
* [TabPy REST API](docs/server-rest.md)
* [TabPy Security Considerations](docs/security.md)

Other useful resources:

* For all questions not related to the TabPy code (installation, deployment,
  connections, Python issues, etc.) and requests use the
  [External Services Forum](https://community.tableau.com/community/forums/externalservices)
  on [Tableau Community](https://community.tableau.com).
* [Building advanced analytics applications with TabPy](https://www.tableau.com/about/blog/2017/1/building-advanced-analytics-applications-tabpy-64916)
* [Building Data Science Applications with TabPy Video Tutorial](https://youtu.be/nRtOMTnBz_Y)
* [TabPy Tutorial on TabWiki](https://community.tableau.com/docs/DOC-10856)

![GitHub commit activity](https://img.shields.io/github/commit-activity/m/tableau/TabPy.svg)
![GitHub forks](https://img.shields.io/github/forks/tableau/TabPy.svg?label=Forks&style=social)
![GitHub stars](https://img.shields.io/github/stars/tableau/TabPy.svg?style=social)
